diff -uNr 3.5/source/conline/line/au9.f unipops-3.6/source/conline/line/au9.f
--- 3.5/source/conline/line/au9.f	2000-03-16 11:34:31.000000000 -0700
+++ unipops-3.6/source/conline/line/au9.f	2008-12-29 14:39:22.000000000 -0700
@@ -7,12 +7,12 @@
 c
 C---------------------------------------------------------------------
 c
-      INTEGER*4  ISTART, ISTOP
-      integer*2 j, iptwh, jj, ix, iy, ierr
+      INTEGER*4  ISTART, ISTOP, ierr
+      integer*2 j, iptwh, jj, ix, iy
       integer*2 m2, m3, n0, n120, n225, n284, n298
       integer*2 n1, n25, n780, n33
       logical isfirst, okreal4
-      real*4 rampltde, rphase, rperiod, ajj, twopi
+      real*4 ajj, twopi
 c
       include 'core.inc'
       include 'cio.inc'
diff -uNr 3.5/source/conline/line/cheader.f unipops-3.6/source/conline/line/cheader.f
--- 3.5/source/conline/line/cheader.f	2000-03-16 11:34:33.000000000 -0700
+++ unipops-3.6/source/conline/line/cheader.f	2008-12-29 14:39:23.000000000 -0700
@@ -4,9 +4,9 @@
 c
 c     Lists out the contents of the header of the current cube
 c
-      integer*2 istch(40), ierr, n, iinitp, n1
+      integer*2 istch(40), n, iinitp, n1
       integer*2 n80
-      integer*4 n24, nchar
+      integer*4 n24, nchar, ierr
       character*80 stch
       character*24 sdate
 c
diff -uNr 3.5/source/conline/line/chngol.F unipops-3.6/source/conline/line/chngol.F
--- 3.5/source/conline/line/chngol.F	2000-03-16 11:34:35.000000000 -0700
+++ unipops-3.6/source/conline/line/chngol.F	2008-12-29 14:39:23.000000000 -0700
@@ -8,8 +8,8 @@
 c     appropriateness of the file type is checked here.  
 c------------------------------------------------------------------------
 c
-      integer*4 iftype, iver
-      integer*2 m1, m2, n300, ier
+      integer*4 iftype, iver, ier
+      integer*2 m1, m2, n300
 c
       include 'cio.inc'
       include 'core.inc'
@@ -19,8 +19,8 @@
 #ifdef CONTINUUM
       if (iftype .ne. 3) call oerror(n300, m1, 'CHNGONLINE')
 #else
-      if (iftype .ne. 1 .and. iftype .ne. 2) 
-     .   call oerror(n300, m1, 'CHNGONLINE')
+      if (iftype .lt. 1 .or. iftype .gt. 6 .or. iftype .eq. 3) 
+     .     call oerror(n300, m1, 'CHNGONLINE')
 #endif
 c
       call chngonline(iftype, iver, projcode, ier)
@@ -29,6 +29,9 @@
       if (iftype .eq. 1) hcver = iver
       if (iftype .eq. 2) fbver = iver
       if (iftype .eq. 3) conver = iver
+      if (iftype .eq. 4) aosver = iver
+      if (iftype .eq. 5) ffbver = iver
+      if (iftype .eq. 6) ctsver = iver
 c
       return
       end
diff -uNr 3.5/source/conline/line/chngver.F unipops-3.6/source/conline/line/chngver.F
--- 3.5/source/conline/line/chngver.F	2000-03-16 11:34:35.000000000 -0700
+++ unipops-3.6/source/conline/line/chngver.F	2008-12-29 14:39:23.000000000 -0700
@@ -14,13 +14,13 @@
 #else
       character*80 cans, uans
 #endif
-      character*2 fb, hc
+      character*2 fb, hc, ff, ao, ct
 c
       include 'cio.inc'
       include 'core.inc'
 c
       data m1, n300 /-1, 300/
-      data fb /'FB'/, hc /'HC'/
+      data fb /'FB'/, hc /'HC'/, ff /'FF'/, ao /'AO'/, ct /'CT'/
 c
 #ifdef CONTINUUM
       if (iftype .eq. -1) iftype = 3
@@ -29,7 +29,8 @@
       if (iftype .eq. -1) then
  100     write(istdout,1000)
  1000    format(' Type of on-line file ',
-     .          '(FB=filterbank, HC=hybrid correlator) : ',$)
+     .          '(FB=filterbank, HC=hybrid correlator
+     .           FFB=Forbes filterbank, AOS, CTS=Chirp): ',$)
          read(istdin, 1010) cans
  1010    format(a80)
          call uppercase(cans, uans)
@@ -37,6 +38,12 @@
             iftype = 2
          else if (uans(1:2) .eq. hc) then
             iftype = 1
+         else if (uans(1:2) .eq. ff) then
+            iftype = 5
+         else if (uans(1:2) .eq. ao) then
+            iftype = 4
+         else if (uans(1:2) .eq. ct) then
+            iftype = 6
          else
             write(istdout, 1020) cans(1:2)
  1020       format(' Unrecognized file type : ',a2)
@@ -44,7 +51,7 @@
          endif
       endif
 c
-      if (iftype .ne. 1 .and. iftype .ne. 2) 
+      if (iftype .lt. 1 .or. iftype .gt. 6 .or. iftype .eq. 3) 
      .   call oerror(n300, m1, 'CHNGVER')
 #endif
 c
@@ -54,6 +61,9 @@
       if (iftype .eq. 1) hcver = iver
       if (iftype .eq. 2) fbver = iver
       if (iftype .eq. 3) conver = iver
+      if (iftype .eq. 4) aosver = iver
+      if (iftype .eq. 5) ffbver = iver
+      if (iftype .eq. 6) ctsver = iver
 c
       return
       end
diff -uNr 3.5/source/conline/line/conversion2.f unipops-3.6/source/conline/line/conversion2.f
--- 3.5/source/conline/line/conversion2.f	2000-03-16 11:30:03.000000000 -0700
+++ unipops-3.6/source/conline/line/conversion2.f	2008-12-29 14:39:22.000000000 -0700
@@ -8,7 +8,7 @@
       include 'params.inc'
       integer*4 maxclass, i, nextout, inclasses, ifirst, j, ilast,
      .		i1, i2, headsize, datalen, noint, spn, 
-     .           maxperclass(20), bootsize
+     .           maxperclass(20), bootsize, byteswap, index
       double precision input(*), output(*)
 c
       integer*2 iindat(16), ioutdat(16), ier
@@ -25,16 +25,27 @@
 c     MAXPERCLASS = max. number of R*8 entries in each class
 c
       ier = 0
+      byteswap = 0
       bootsize = (maxclass+5)/4
       do 10 i = 1, bootsize
 	dindat(i) = input(i)
 10	continue
-c     Move class descriptors into DINDAT
+c     Move int*2 class descriptors into DINDAT as R*8's
+c     N.B.  They haven't yet been byteswapped.
+c     We'll do that manipulation with the iindat array next...
 c
       nextout = bootsize + 1
 c     nextout = location in OUTPUT where next class starts
 c
+c     do we need to byte swap?  Let's check the number of classes to see.
+      if (iindat(1) .gt. maxclass) then
+         byteswap=1
+         call swapINT2(iindat(1))
+         call swapINT2(iindat(2))
+         call swapR8(input(iindat(2)))
+      endif
       headsize = input(iindat(2))/8.d0
+c     This is the first entry in class 1 (headlen is a R*8)
       if (headsize*8 .ne. nint(input(iindat(2)))) 
      .		headsize = headsize + 1
 c     headsize = num. R*8 words in input header
@@ -43,24 +54,69 @@
       ioutdat(1) = inclasses
       ioutdat(2) = (inclasses+5)/4 + 1
 c     Find max number of classes needed, up to above limit and
-c     start puting new class descriptors into DOUTDAT
+c     start putting new class descriptors into DOUTDAT
 c
+
       do 100 i = 1, inclasses
 	ifirst = iindat(i+1)
+c       this should already be byteswapped as needed
 	if (ifirst .lt. 0) then
 	   ier = -1
 	   goto 99
 	endif
+c       byteswap the next iindat entry if needed
+        if(byteswap .eq. 1) call swapINT2(iindat(i+2))
 	ilast = ifirst + min(maxperclass(i), iindat(i+2)-ifirst) - 1
         if (i .eq. inclasses .and. ilast .lt. ifirst) then
 	    ilast = min(ifirst+maxperclass(i), headsize )
 	else if (i .ne. inclasses .and. ilast .lt. ifirst) then
-	    ier = -1
 	    goto 99
 	endif
 	ioutdat(i+2) = ioutdat(i+1) + ilast - ifirst + 1
 	if (i .ne. 1) nextout = nextout + maxperclass(i-1)
         do 50 j = ifirst, ilast
+c          normally we'd just do a swapR8(), but we don't want to 
+c          swap character arrays.  So we have to special-case them out. 
+c          You should have your barf bags out for this part, kids! 
+           if(byteswap .eq. 1) then
+              index = j-ifirst+1
+c          we've already swapped index=1 and i=1 (headerlen, see above)
+              if(i.eq.1) then 
+                 if(index.gt.1 .and. index.lt.4) then 
+                    call swapR8(input(j))
+                 endif
+              else if (i.eq.1 .and. index.gt.14) then
+                 call swapR8(input(j))
+              else if (i.eq.2 .and. index.lt.13) then 
+                 call swapR8(input(j))
+              else if (i.eq.3 .and. index.lt.9) then 
+                 call swapR8(input(j))
+              else if (i.eq.3 .and. index.gt.9) then 
+                 call swapR8(input(j))
+              else if (i.eq.4 .and. index.lt.17) then 
+                 call swapR8(input(j))
+              else if (i.eq.5) then 
+                 call swapR8(input(j))
+              else if (i.eq.6 .and. index.lt.11) then 
+                 call swapR8(input(j))
+              else if (i.eq.7 .and. index.lt.6) then 
+                 call swapR8(input(j))
+              else if (i.eq.8) then 
+                 call swapR8(input(j))
+c     This next entry is for the 12m.  Green Bank has a 3 byte char array
+c     at the end of class 9.  But who cares? :)
+              else if (i.eq.9) then 
+                 call swapR8(input(j))
+              else if (i.eq.11 .and. index.lt.8) then 
+                 call swapR8(input(j))
+              else if (i.eq.12 .and. index.lt.21) then 
+                 call swapR8(input(j))
+              else if (i.eq.12 .and. index.eq.22) then 
+                 call swapR8(input(j))
+              else if (i.eq.13) then 
+                 call swapR8(input(j))
+              endif
+           endif
 	   output(j-ifirst+nextout) = input(j)
 50	   continue
 c	Move header items from INPUT to OUTPUT at their correct locations
@@ -100,13 +156,15 @@
 	ier = -1
 	goto 99
       endif
-c     Find where the data is in INPUT give up if no header info
+c     Find where the data is in INPUT; give up if no header info
 c
       if (i2 .ge. i1) then
 c	Move the data from INPUT to OUTPUT
 c		only do this if there really is some data there
-c		this isn't strictly necessary, but I think its clearer
-         do 300 i = i1, i2
+c		this isn't strictly necessary, but I think its clearer.
+c       And byteswap the R*4 data within each R*8 as needed
+         do 300 i = i1, i2            
+            if(byteswap .eq. 1) call swapR4inR8(input(i))
 	    output(i-i1+nextout) = input(i)
 300	 continue
       endif
diff -uNr 3.5/source/conline/line/cube.f unipops-3.6/source/conline/line/cube.f
--- 3.5/source/conline/line/cube.f	2000-03-16 11:34:37.000000000 -0700
+++ unipops-3.6/source/conline/line/cube.f	2008-12-29 14:39:23.000000000 -0700
@@ -11,12 +11,12 @@
       parameter (nwrds4 = 720)
       parameter (nwrds8 = 360)
 c
-      integer*2 oldrec, record, ldata2(nwrds2), blankfits2, ierr
+      integer*2 oldrec, record, ldata2(nwrds2), blankfits2
       character*1 cdata1(nwrds1)
       real rdata4(nwrds4)
       double precision rdata8(nwrds8)
       integer*2 m1, n357, n365
-      integer*4 l1, long, ldata4(nwrds4)
+      integer*4 l1, ldata4(nwrds4), ierr
       integer*4 iloc, position, blankfits1, blankfits4
       logical okreal4, okreal8
 c
@@ -34,8 +34,8 @@
       data oldrec/0/
 c     OLDREC = value of last record read in
 c
-      iloc = long(ii) + nint(chead(cnaxis1))* ( long(jj-1) 
-     .           + nint(chead(cnaxis2))* long(kk-1) )
+      iloc = int(ii) + nint(chead(cnaxis1))* ( int(jj-1) 
+     .           + nint(chead(cnaxis2))* int(kk-1) )
 c
       if ( abs(nint(chead(cbitpix))) .eq. 16) then
 	nwrds = nwrds2
diff -uNr 3.5/source/conline/line/drawcntr.f unipops-3.6/source/conline/line/drawcntr.f
--- 3.5/source/conline/line/drawcntr.f	2000-03-16 11:34:38.000000000 -0700
+++ unipops-3.6/source/conline/line/drawcntr.f	2008-12-29 14:39:23.000000000 -0700
@@ -9,7 +9,7 @@
       integer*2 nseg, ictr, sclc, ipixel, jseg1, curcur
       integer*2 ixtmp, iytmp, n1, n2, n8, n14
       real savevec(4,*), undefwp
-      integer*4 isize, jsize
+      integer*4 isize, jsize, ierr
 c
       include 'mappl.inc'
       include 'appl.inc'
@@ -20,7 +20,7 @@
       character*10 fmt, getformat
       real alabel,xold,yold,xfst,yfst,rad,direc,alength,
      .	   xlst,ylst, ep4 
-      integer*2 kseg, jseg, lseg, ierr
+      integer*2 kseg, jseg, lseg
 c
       data n1, n2, n8, n14 /1, 2, 8, 14/
 c
diff -uNr 3.5/source/conline/line/funct.F unipops-3.6/source/conline/line/funct.F
--- 3.5/source/conline/line/funct.F	2000-03-16 11:34:40.000000000 -0700
+++ unipops-3.6/source/conline/line/funct.F	2008-12-29 14:39:24.000000000 -0700
@@ -1,24 +1,25 @@
       SUBROUTINE  FUNCT	(LFLAG,J)
-C-------------------------------------------------------------------------------
+C-----------------------------------------------------------------------------
 C  @(#)funct.F	5.2 05/04/98
-C-------------------------------------------------------------------------------
-C---------------------------------------------------------------------
+C-----------------------------------------------------------------------------
 C FUNCT contains frequently used fortran builtin functions
 C---------------------------------------------------------------------
 c
       integer*2 jj, lflag, j, iptwh2, icnum, istop, i1, loc, isize,
      .		isize2, iwpr, irealp, itype, numi2, numi4,
-     .		i, lastblnk, i2, i3, itag, isize1, ierr, ier,  
+     .		i, lastblnk, i2, i3, itag, isize1,
      .		iwpc, openmode, rwmode, exmode, posmode, SCR, NEW, OLD,
      .		UNK, EOF, REW, RO, WO, RW, iused
       integer*2 m1, m2, m3, n1, n30, n112, n120, n272, n225, n245, 
-     .		n28, n352, n370, n299
+     .		n28, n352, n370, n299, ierr
       real*4 cube, rcompar2(30), rcompar1(30), rchan
-      integer*4 ilct, index, ioget, iunit, slen, sused
+      integer*4 ilct, index, ioget, iunit, slen, sused, ier
       logical string
+      character*1 tempchar
       character*60 compar1, compar2
       character*1023 fullname
-      real*8 nrao140, nrao300, proto12m, x1, x2, dinfinity
+      character*8 nrao140, nrao300, proto12m, smt
+      real*8 x1, x2, dinfinity, value12m, value140, value300, valuesmt
       character*8 stat
       double precision chantox, xtochan
 c
@@ -31,12 +32,18 @@
       INCLUDE 'mappl.inc'
 c
       equivalence (compar1, rcompar1), (compar2, rcompar2)
+c     we need these equivalences, because g77 can't declare chars as reals
+c     (ex. NRAO declared proto12m as a real*8; we must have it as char*8)
+      equivalence (proto12m, value12m)
+      equivalence (smt, valuesmt)
+      equivalence (nrao140, value140)
+      equivalence (nrao300, value300)
 c
       data m1, m2, m3, n1, n28, n30, n112, n120, n272, n225, n245, n352
      .     /-1, -2, -3, 1, 28, 30, 112, 120, 272, 225, 245, 352/
       data n370, n299 /370, 299/
       data nrao140/'NRAO 43M'/, nrao300/'NRAO 93M'/
-      data proto12m /'PROTO12M'/
+      data proto12m /'PROTO12M'/, smt/'ARO-HHT'/
 c
       parameter (UNK = 0)
       parameter (OLD = 1)
@@ -111,7 +118,7 @@
       GO TO 5001
    46 CONTINUE
       if (sp.lt.1) call oerror(n112, m1, 'IFIX : One needed')
-      XX=FLOAT(IFIX(V(SP)))
+      XX=FLOAT(int(V(SP)))
       GO TO 5001
    47 CONTINUE
       if (sp.lt.2) call oerror(n112, m1, 'MAX : Two needed')
@@ -297,11 +304,12 @@
 1150	    continue
 c	 Find out if it is a string header word
 c	 Deal with class 9 and class 11 special cases
-	 if (i1 .eq. c9cff .and. dtwh(c1tel,iptwh2) .ne. nrao140 .and.
-     .		dtwh(c1tel,iptwh2) .ne. nrao300) string = .false.		
+	 if (i1 .eq. c9cff .and. dtwh(c1tel,iptwh2) .ne. value140 .and.
+     .		dtwh(c1tel,iptwh2) .ne. value300) string = .false.
          if (i1 .gt. c11ovv(1) .and. i1 .lt. c12fr .and. string) then
             string = .false.
-            if (dtwh(c3typ11,iptwh2) .eq. proto12m) then
+            if (dtwh(c3typ11,iptwh2) .eq. value12m .or.
+     .          dtwh(c3typ11,iptwh2) .eq. valuesmt) then
                do 1240 i = 1, 10
                   if (i1 .eq. c11pvd(i) .or. i1 .eq. c11ppt(i))
      .                        string = .true.
@@ -574,7 +582,7 @@
      .		'FOPEN: Scratch file cannot be opened for reading')
         iunit = ioget()
         if (iunit .lt. 0) call oerror(n28, m1, 'FOPEN')
-	open(unit=iunit, access='sequential', form='print', iostat=ier,
+	open(unit=iunit, access='sequential', form='formatted', iostat=ier,
      .		status='scratch')
 c
       else if (exmode .eq. NEW) then
@@ -585,7 +593,7 @@
         iunit = ioget()
         if (iunit .lt. 0) call oerror(n28, m1, 'FOPEN')
         call filecomp(compar1, fullname)
-	open(unit=iunit, access='sequential', form='print', iostat=ier,
+	open(unit=iunit, access='sequential', form='formatted', iostat=ier,
      .		status='new', file = fullname)
 c
       else if (exmode .eq. OLD .or. exmode .eq. UNK) then
@@ -599,13 +607,15 @@
         iunit = ioget()
         if (iunit .lt. 0) call oerror(n28, m1, 'FOPEN')
         call filecomp(compar1, fullname)
+        open(unit=iunit, access='sequential', form='formatted', 
+     .       iostat=ier, status= stat, file = fullname)
 	if (posmode .eq. EOF) then
-	   open(unit=iunit, access='sequential', form='print', iostat=ier,
-     .		status= stat, file = fullname, fileopt='eof')
-	else
-	   open(unit=iunit, access='sequential', form='print', iostat=ier,
-     .		status= stat, file = fullname)
-	endif
+c     g77 can't do fileopt=eof, so we'll seek there ourselves
+           do while (.true.)
+              read (iunit, end=100, fmt='(A1)') tempchar
+           end do
+c     should be at EOF now
+ 100    endif
 c
       else
         call oerror(n112, m1, 'FOPEN: Bad open parameter')
@@ -1020,7 +1030,7 @@
 c			how long is the string, result on stack must be mult of 4
          isize1 = lastblnk(compar1)
          if (isize1 .eq. 0) call oerror(n370, m2, 'FNAME')
-         if (mod(isize1, 4)  .ne. 0) isize1 = (ifix(isize1/4) + 1) * 4
+         if (mod(isize1, 4)  .ne. 0) isize1 = (int(isize1/4) + 1) * 4
 c			store contents of string into K array
          numi2 = min(n30, iwpc(isize1))
          call runtag(numi2, itag)
diff -uNr 3.5/source/conline/line/getbyloc.f unipops-3.6/source/conline/line/getbyloc.f
--- 3.5/source/conline/line/getbyloc.f	2000-03-16 11:34:45.000000000 -0700
+++ unipops-3.6/source/conline/line/getbyloc.f	2008-12-29 14:39:24.000000000 -0700
@@ -56,7 +56,7 @@
 c
       return
 c
- 20   format('Unknown disk error code ', i)
+ 20   format('Unknown disk error code ', i1)
 c
       end
 c
diff -uNr 3.5/source/conline/line/getbynum.f unipops-3.6/source/conline/line/getbynum.f
--- 3.5/source/conline/line/getbynum.f	2000-03-16 11:34:46.000000000 -0700
+++ unipops-3.6/source/conline/line/getbynum.f	2008-12-29 14:39:24.000000000 -0700
@@ -18,8 +18,9 @@
       character*(*) filename
       character*80 stch
       double precision array(*), xdata(maxsize)
-      integer*2 iunit, ierr, imagic, ier
+      integer*2 iunit, imagic
       integer*2 n80, n120, m3
+      integer*4 ier, ierr
       real scan, location
 c
       data n80, n120, m3 /80, 120, -3/
@@ -55,7 +56,7 @@
 c
       return
 c
- 20   format('Unknown disk error code ', i)
+ 20   format('Unknown disk error code ', i1)
 c
       end
 c
diff -uNr 3.5/source/conline/line/getlist.f unipops-3.6/source/conline/line/getlist.f
--- 3.5/source/conline/line/getlist.f	2000-03-16 11:34:46.000000000 -0700
+++ unipops-3.6/source/conline/line/getlist.f	2008-12-29 14:39:24.000000000 -0700
@@ -11,8 +11,8 @@
 c      
       character*(*) filename
       real scans(*)
-      integer*2 number, iunit, max, ierr
-      integer*4 lunit, lmax, lnumber, lrtn
+      integer*2 number, iunit, max
+      integer*4 lunit, lmax, lnumber, lrtn, ierr
 c
       number = 0
       ierr = 0
diff -uNr 3.5/source/conline/line/gmeasure.f unipops-3.6/source/conline/line/gmeasure.f
--- 3.5/source/conline/line/gmeasure.f	2000-03-16 11:34:48.000000000 -0700
+++ unipops-3.6/source/conline/line/gmeasure.f	2008-12-29 14:39:25.000000000 -0700
@@ -80,7 +80,7 @@
       include 'appl.inc'
       include 'cform.inc'
 c
-      Real F(5),SMx,Smax,S,Dex,f
+      Real F(5),SMx,Smax,S,Dex,ff
       Real SDV(5),W(5),V(5),pr1,pr2,pr3, dv(5)
       Real RMS,SFAC,wrd(5), velrms
 c
@@ -88,11 +88,11 @@
 c     
       Integer*4        I, J, Imax, il, ir, channo, firstch
       Integer*4        gmeasK(5), jl(5), jr(5), ibx
-      Integer*4        iostatus, istart, istop, chanil, chanir
+      Integer*4        iostatus, istart, istop, chanil, chanir, ier
 c
       character*80 stch
       integer*2 istch(40), short, inn, iptwh, nb, inn2, n80, n292, m1,
-     .		iymm10, n112, ierr, n225, m2, n0, n270, lxa1, n268
+     .		iymm10, n112, n225, m2, n0, n270, lxa1, n268, ierr
       logical okarray, okreal4, first
 c
       EQUIVALENCE (istch, stch)
@@ -136,7 +136,7 @@
       IF (PR1.le.0.) THEN
 229      call pread2( 'Enter string of modes to measure:', stch, nb)
          READ (stch,*,iostat=iostatus) PR1
-	 if (iostatus.ne.0 .or. PR1 .eq. '0.') then
+	 if (iostatus.ne.0 .or. PR1 .eq. 0.0) then
 		stch = 'Bad input... Try again'
 		call pwrite(istch, n80)
 		goto 229
@@ -240,7 +240,7 @@
 c
 	 chanIL = IL + firstch - 1
          chanIR = IR + firstch - 1
-         WRITE (stch,109,iostat=ierr) chanIL,chanIR,SDV(I),V(I),
+         WRITE (stch,109,iostat=ier) chanIL,chanIR,SDV(I),V(I),
      *            (JL(I)+firstch-1), (JR(I)+firstch-1),W(I)
   109    FORMAT (" area(",I3,",",I4,") =",E10.4,
      *           " Center =",F8.1,3X," Width(",I3,",",I4,") =",F8.1)
@@ -256,7 +256,7 @@
 C           velocity resolution caused by smoothing
 c           
 	    dv(i) = VELRMS*sfac
-            WRITE(stch,901,iostat=ierr)  dv(i)
+            WRITE(stch,901,iostat=ier)  dv(i)
  901        FORMAT (28X,'DeltaV =',F6.2)
 	    call pwrite(istch, n80)
 	 else
@@ -351,7 +351,7 @@
 ********************************************************************************
 C
       Real X(*),Y(*),SDV,AVE,BL,FRAC,BR,V,W,FLevel
-      Real Sdv, F,RMS,VR,VL
+      Real F,RMS,VR,VL
       Integer*4        Ifirst, last, JR, J, JL, I
 c
       integer*2 n229, n0
@@ -665,13 +665,13 @@
 
       INTEGER*4 IFIRST,ILAST,NORDER,
      *          IFR1L,IFR2L,IFRL,IFR1R,IFR2R,
-     *          IFRR,I,IPL,IPR,J
+     *          IFRR,I,IPL,IPR,J, ios
       Real VFRL,VFRR,YFRL,YFRR,dV,A(3),
-     *                 FR1,FR2,FR,FPL,FPR,FPL,B(3),
+     *                 FR1,FR2,FR,FPL,B(3),
      *                 FRMS,VRMSL,VRMSR,VRMS,
      *                 COVAR(3,3),TEMP
       character*80 stch
-      integer*2 istch(40), nb, n80, IOS
+      integer*2 istch(40), nb, n80
 c
       equivalence (istch, stch)
 
@@ -988,7 +988,7 @@
          WRITE(stch,'(2f6.1)',iostat=ios) FTST1,FTST2
          call pwrite(istch,n80)
          write(stch,10,iostat=ios) IFR1L-IFR2L+1,IFR2R-IFR1R+1
- 10      format('# of points used to fit l & r halves are',x,i3,x,i3 )
+ 10      format('# of points used to fit l & r halves are',1x,i3,1x,i3 )
 	 call pwrite(istch, n80)
 
 	 retry = .true.
@@ -1183,13 +1183,13 @@
       INTEGER*4 IFIRST,ILAST,NORDER,
      *          IFR1L,IFR2L,IFRL,IFR1R,IFR2R,
      *          IFRR,I,IPL,IPR, ifrp1, ifrm1, n1,
-     *          IFRR1,IFRR2,IFRL1,IFRL2
+     *          IFRR1,IFRR2,IFRL1,IFRL2, ios
       Real VFRL,VFRR,YFRL,YFRR,dV,A(3),
-     *                 FR1,FR2,FR,FPL,FPR,FPL,
+     *                 FR1,FR2,FR,FPR,FPL,
      *                 VRMSL,VRMSR,VRMS,COVAR(3,3),
      *                 YFRL1,YFRL2,YFRR1,YFRR2,TEMP
       character*80 stch
-      integer*2 istch(40), nb, n80, IOS
+      integer*2 istch(40), nb, n80
 c
       equivalence (istch, stch)
 
@@ -1475,7 +1475,7 @@
          WRITE(stch,'(2f6.1)',iostat=ios) FTST1,FTST2
          call pwrite(istch,n80)
          write(stch,10,iostat=ios) IFR1L-IFR2L+1,IFR2R-IFR1R+1
- 10      format('# of points used to fit l & r halves are',x,i3,x,i3 )
+ 10      format('# of points used to fit l & r halves are',1x,i3,1x,i3 )
          call pwrite(istch,n80)
 
 	 retry = .true.
@@ -1837,9 +1837,9 @@
       INTEGER*4 I1,I2,NORDER
       Real XA(NMAX),YA(NMAX),SIG(NMAX)
       Real COVAR(NCVM,NCVM),CHISQR
-      INTEGER*4 MFIT,MA,NDATA,LISTA(NCVM),I,NFREE
+      INTEGER*4 MFIT,MA,NDATA,LISTA(NCVM),I,NFREE, ios
       character*80 stch
-      integer*2 istch(40), ios, n80
+      integer*2 istch(40), n80
 c
       external funcs
 c
diff -uNr 3.5/source/conline/line/header.F unipops-3.6/source/conline/line/header.F
--- 3.5/source/conline/line/header.F	2000-03-16 11:34:54.000000000 -0700
+++ unipops-3.6/source/conline/line/header.F	2008-12-29 14:39:25.000000000 -0700
@@ -3,18 +3,19 @@
 C  @(#)header.F	5.3 09/10/98
 C-------------------------------------------------------------------------------
 c 
-c     Prints either GB or 12M header
+c     Prints either GB or 12M/SMT header
 c
 c************************************
       INTEGER*4 ISTC(2), IOBSOPR(2), ivdef(2), bsp
       INTEGER*2 STR1(4), STR2(4), STR5(4), STR6(4), STR7(4), STR8(4),
      .		RSTRNG2(6), DSTRNG3(6), estrng(6), lstrng(6), ipuf(40),
-     .		imon, iday, iyear, ier, imonth, rrstr(6), rdstr(6)
+     .		imon, iday, iyear, imonth, rrstr(6), rdstr(6)
       integer*2 m2, n0, n1, n2, n3, n80, n283
-      integer*4 iptwh, i, j, icdtype 
-      real*8  T03, ctype(8), t12m, nrao140, nrao300, vdef, SOURCE(2), 
-     .	      OBSNAME(2), STC, OBSOPR, UDATE, digit, dfform(3), 
-     .	      dcoordcode
+      integer*4 iptwh, i, j, icdtype, ier
+      character*8  digit, ctype(8), t12m, nrao140, nrao300, smt
+      real*8  T03, vdef, SOURCE(2), 
+     .	    OBSNAME(2),STC, OBSOPR, UDATE, dfform(3), value(8),
+     .	    dcoordcode, value300, value12m, value140, valuesmt, valuedig
       real*4 lst, ut, ra, dec, az, el, sx, sy, rx, ry
       character*80 cpuf
       character*24 cfform
@@ -46,8 +47,16 @@
       equivalence (cpuf, ipuf), (stc,istc), (obsopr,iobsopr)
       equivalence (rstrng2, crstrng2), (dstrng3, cdstrng3)
       equivalence (rrstr, crrstr), (rdstr, crdstr)
+c     we need these equivalences, because g77 can't declare chars as reals
+c     (ex. NRAO declared t12m as a real*8; we have to have it as char*8)
+      equivalence (t12m, value12m)
+      equivalence (nrao140, value140)
+      equivalence (nrao300, value300)
+      equivalence (smt, valuesmt)
+      equivalence (digit, valuedig)
+      equivalence (ctype, value)
 c
-      DATA BSP/'BSP '/
+      DATA BSP/'BSP '/,smt/'ARO-HHT'/
       data nrao140/'NRAO 43M'/,nrao300/'NRAO 93M'/,t12m/'NRAO 12M'/
       data T03 /0.001d0/, digit/'DIGITAL '/
 c
@@ -59,9 +68,11 @@
 c
       iptwh = 1
 c
-      if(dtwh(c1tel,iptwh).eq.nrao140 .or. 
-     .		dtwh(c1tel,iptwh).eq.nrao300) goto 20
-      if(dtwh(c1tel,iptwh).ne.t12m) call oerror(n283, m2, 'HEADER')
+      if(dtwh(c1tel,iptwh).eq.value140 .or. 
+     .		dtwh(c1tel,iptwh).eq.value300) goto 20
+c
+      if(dtwh(c1tel,iptwh).ne.value12m .and.
+     .   dtwh(c1tel,iptwh).ne.valuesmt) call oerror(n283, m2, 'HEADER')
 c
       DO 11 I = 1,2
          SOURCE(I)=DTWH(C1SNA+I-1,IPTWH)
@@ -105,7 +116,7 @@
       rx = dtwh(c4rx, iptwh)
       ry = dtwh(c4ry, iptwh)
       do 100 icdtype = 1, 8
-         if (dcoordcode .eq. ctype(icdtype)) goto 110
+         if (dcoordcode .eq. value(icdtype)) goto 110
  100  continue
  110  if (coordcode .eq. 'USERDEF ' .or. icdtype .gt. 8 .and.
      .    coordcode .ne. 'GALACTIC') then
@@ -367,7 +378,7 @@
  3008 FORMAT(33X,F10.8,15X,F5.0)
  3009 FORMAT(2X,'TIME',3X,'NS',4X,'SEC',7X,'VEL',4X,a5,'/VR',3X,
      .       'VEL/CHAN',3X,'TOL',5X,'F0')
- 3010 FORMAT(1X,F5.1,I5,F9.1,F11.2,F9.3,F10.3,F7.0,F7.1,x,a4)
+ 3010 FORMAT(1X,F5.1,I5,F9.1,F11.2,F9.3,F10.3,F7.0,F7.1,1x,a4)
  3011 format('V',a4)
 c
 c
@@ -467,7 +478,7 @@
 c     Don't repeat a coordinate that will already be on the output
 c
       do 233 icdtype = 1, 8
-	if (dcoordcode .eq. ctype(icdtype)) then
+	if (dcoordcode .eq. value(icdtype)) then
             CALL RNS ( RA,n2,RSTRNG2)
             CALL RNS (DEC,n1,DSTRNG3)
             write (unit=cpuf,fmt=2547,iostat=ier) coordcode,
@@ -491,7 +502,7 @@
      .       '  N.Tube  (Counts/K)')
       call pwrite(ipuf,n80)
 c
-      if (dtwh(c1bke,iptwh) .eq. digit) then
+      if (dtwh(c1bke,iptwh) .eq. valuedig) then
 	TSYS   = dTWH(c12sst,IPTWH)
         bw  = dTWH(c12bw,IPTWH)
       else
diff -uNr 3.5/source/conline/line/initappl.f unipops-3.6/source/conline/line/initappl.f
--- 3.5/source/conline/line/initappl.f	2000-03-16 11:34:58.000000000 -0700
+++ unipops-3.6/source/conline/line/initappl.f	2008-12-29 14:39:25.000000000 -0700
@@ -10,8 +10,7 @@
       INCLUDE 'mform.inc'
 C
 C
-      integer*4 inf, iiappl
-      integer*2 i
+      integer*4 inf, iiappl, i
       logical*2 first
       real*4 rinf, rinfinity
       real*8 dinf, dinfinity
diff -uNr 3.5/source/conline/line/itfits.F unipops-3.6/source/conline/line/itfits.F
--- 3.5/source/conline/line/itfits.F	2000-03-16 11:34:58.000000000 -0700
+++ unipops-3.6/source/conline/line/itfits.F	2008-12-29 14:39:25.000000000 -0700
@@ -5,9 +5,9 @@
 c      function used by select to see if the values of the various
 c      index fields fit the selection criteria stored in core
 c
-      integer*2 idat(1)
-      integer*2 index(32), i4pc, i8pc, i16pc, ii, iobsmode, obs, mode
-      integer*2 is_mode, irtn, lastblnk
+      integer*2 idat(1), index(32), lastblnk
+      integer*2 i4pc, i8pc, i16pc, ii, iobsmode, obs, mode
+      integer*2 is_mode, irtn
       integer*2 n1, n2, n4, n5, n7, n8, n9, n17, n19, n21, n25, n27
       integer*4 i1, inrange, inrange8
       real*4 rindex(16), scanno, feedno, sourcex, sourcey, lst, ut_date
@@ -59,8 +59,8 @@
 c				scan and feed number
 c				scan number is just truncated but
 c				feed number needs to be nearest int
-      scanno = int(rindex(i4pc(n17)))
-      feedno = nint((rindex(i4pc(n17)) - scanno) * 100.0)
+      scanno = aint(rindex(i4pc(n17)))
+      feedno = anint((rindex(i4pc(n17)) - scanno) * 100.0)
 c
       if (localfit) localfit = localfit .and. 
      .     (inrange(scan_min, scan_max, scanno, default) .eq. 1)
